<?php

namespace Modules\Gallery\Controllers\Admin;

/** Ajax Request */

use App\Services\Response\ResponseService;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use App\Http\Controllers\Controller;
use Modules\Gallery\Requests\Admin\GalleryRequest;
use Modules\Gallery\Enums\GalleryStatusEnum;
use Modules\Gallery\Services\GalleryService;

class GalleryController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/galleries';
    /** View folder */
    private $viewDirectory= 'admin.galleries.';
    //

    public function __construct(
        private GalleryService $galleryService,
    )
    {}

    /**
     * Display a listing of the galleries.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('galleries.head');
        $statuses = GalleryStatusEnum::values();
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the galleries.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $request->merge(['paginate'=>true]);
        $galleries= $this->galleryService->get($request->all());

        return view($this->viewDirectory.'grid',get_defined_vars());
    }

    /**
     * Show the form for creating a new Attribute.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('galleries.store');
        $head= __('galleries.new');
        $statuses = GalleryStatusEnum::values();
        $videoType = GalleryStatusEnum::VIDEO->value;
        $imageType = GalleryStatusEnum::IMAGE->value;
        $linkType = GalleryStatusEnum::LINK->value;
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Store a newly created Attribute in storage.
     * @param GalleryRequest $request
     * @return JsonResponse
     */
    public function store(GalleryRequest $request) :JsonResponse
    {
        $this->galleryService->create($request->validated());

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('galleries.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified Attribute.
     *
     * @param  int $id
     * @return View
     */
    public function edit(int $id) :View
    {
        $gallery = $this->galleryService->getItem($id);
        if (!$gallery)
        {
            abort(404);
        }
        $action= route('galleries.update', $gallery->id);
        $head= __('galleries.edit');
        $statuses = GalleryStatusEnum::values();
        $videoType = GalleryStatusEnum::VIDEO->value;
        $imageType = GalleryStatusEnum::IMAGE->value;
        $linkType = GalleryStatusEnum::LINK->value;
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }


    /**
     * Update the specified Attribute in storage.
     * @param GalleryRequest $request
     * @param int $id
     * @return JsonResponse
     */
    public function update(GalleryRequest $request, int $id) :JsonResponse
    {
        $gallery = $this->galleryService->checkItem($id);
        if (!$gallery)
        {
            abort(404);
        }
        $this->galleryService->update($request->validated(), $id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('galleries.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified Attribute from storage.
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(int $id) :JsonResponse
    {
        $this->galleryService->destroy($id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('galleries.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove several galleries by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $this->galleryService->destroyAll([
            'ids' => $request->ids,
            'status' => 1
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('galleries.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore the specified Attribute from storage.
     *
     * @param int $id
     * @return JsonResponse
     */
    public function restore(int $id) :JsonResponse
    {
        $this->galleryService->destroy($id);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('galleries.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore several galleries by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $this->galleryService->destroyAll([
            'ids' => $request->ids,
            'status' => 0
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('galleries.index'),
        ];
        return ResponseService::response($response);
    }
}
